from RPi import GPIO
from time import sleep


class Switch:

	#
	# Switch status
    ON = 1
    OFF = 2


    def __init__(self, pin_switch, callback_client):
        # Input parameters
        #   - pins number of switch
        #   - client function to call when switch is activated
        #
        #
        self.pin_switch = pin_switch
        self.callback_client = callback_client
        
        GPIO.setup(self.pin_switch, GPIO.IN, pull_up_down=GPIO.PUD_DOWN)
        # Detect both rising and falling edges (switch on and switch off)
        GPIO.add_event_detect(self.pin_switch, GPIO.BOTH, callback=self.switchEventHandler, bouncetime=300)


    def switchEventHandler(self, channel):
        #
        # Called when switch event detected, send the status to the client function
        #
        sleep(0.05)
        status = self.getStatus()
        self.callback_client(status)


    def getStatus(self):
        #
        # Returns the switch status
        #
        if GPIO.input(self.pin_switch) == GPIO.LOW:
        	print("power is OFF")
        	status = self.OFF
        else:
            print("power is ON")
            status = self.ON
        return status

 